diff --git a/src/backend/snowball/libstemmer/stem_ISO_8859_1_english.c b/src/backend/snowball/libstemmer/stem_ISO_8859_1_english.c
index 141c45dc27..87ff8041aa 100644
--- a/src/backend/snowball/libstemmer/stem_ISO_8859_1_english.c
+++ b/src/backend/snowball/libstemmer/stem_ISO_8859_1_english.c
@@ -887,77 +861,76 @@ static int r_Step_5(struct SN_env * z) {
     return 1;
 }
 
-static int r_exception2(struct SN_env * z) {
+static int r_exception2(struct SN_env * z) { /* backwardmode */
     z->ket = z->c; /* [, line 158 */
-    if (z->c - 5 <= z->lb || (z->p[z->c - 1] != 100 && z->p[z->c - 1] != 103)) return 0;
-    if (!(find_among_b(z, a_9, 8))) return 0; /* substring, line 158 */
+    if (z->c - 5 <= z->lb || (z->p[z->c - 1] != 100 && z->p[z->c - 1] != 103)) return 0; /* substring, line 158 */
+    if (!(find_among_b(z, a_9, 8))) return 0;
     z->bra = z->c; /* ], line 158 */
     if (z->c > z->lb) return 0; /* atlimit, line 158 */
     return 1;
 }
 
-static int r_exception1(struct SN_env * z) {
+static int r_exception1(struct SN_env * z) { /* forwardmode */
     int among_var;
     z->bra = z->c; /* [, line 170 */
-    if (z->c + 2 >= z->l || z->p[z->c + 2] >> 5 != 3 || !((42750482 >> (z->p[z->c + 2] & 0x1f)) & 1)) return 0;
-    among_var = find_among(z, a_10, 18); /* substring, line 170 */
+    if (z->c + 2 >= z->l || z->p[z->c + 2] >> 5 != 3 || !((42750482 >> (z->p[z->c + 2] & 0x1f)) & 1)) return 0; /* substring, line 170 */
+    among_var = find_among(z, a_10, 18);
     if (!(among_var)) return 0;
     z->ket = z->c; /* ], line 170 */
     if (z->c < z->l) return 0; /* atlimit, line 170 */
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 170 */
         case 1:
-            {   int ret = slice_from_s(z, 3, s_37); /* <-, line 174 */
+            {   int ret = slice_from_s(z, 3, s_27); /* <-, line 174 */
                 if (ret < 0) return ret;
             }
             break;
         case 2:
-            {   int ret = slice_from_s(z, 3, s_38); /* <-, line 175 */
+            {   int ret = slice_from_s(z, 3, s_28); /* <-, line 175 */
                 if (ret < 0) return ret;
             }
             break;
         case 3:
-            {   int ret = slice_from_s(z, 3, s_39); /* <-, line 176 */
+            {   int ret = slice_from_s(z, 3, s_29); /* <-, line 176 */
                 if (ret < 0) return ret;
             }
             break;
         case 4:
-            {   int ret = slice_from_s(z, 3, s_40); /* <-, line 177 */
+            {   int ret = slice_from_s(z, 3, s_30); /* <-, line 177 */
                 if (ret < 0) return ret;
             }
             break;
         case 5:
-            {   int ret = slice_from_s(z, 3, s_41); /* <-, line 178 */
+            {   int ret = slice_from_s(z, 3, s_31); /* <-, line 178 */
                 if (ret < 0) return ret;
             }
             break;
         case 6:
-            {   int ret = slice_from_s(z, 3, s_42); /* <-, line 182 */
+            {   int ret = slice_from_s(z, 3, s_32); /* <-, line 182 */
                 if (ret < 0) return ret;
             }
             break;
         case 7:
-            {   int ret = slice_from_s(z, 5, s_43); /* <-, line 183 */
+            {   int ret = slice_from_s(z, 5, s_33); /* <-, line 183 */
                 if (ret < 0) return ret;
             }
             break;
         case 8:
-            {   int ret = slice_from_s(z, 4, s_44); /* <-, line 184 */
+            {   int ret = slice_from_s(z, 4, s_34); /* <-, line 184 */
                 if (ret < 0) return ret;
             }
             break;
         case 9:
-            {   int ret = slice_from_s(z, 5, s_45); /* <-, line 185 */
+            {   int ret = slice_from_s(z, 5, s_35); /* <-, line 185 */
                 if (ret < 0) return ret;
             }
             break;
         case 10:
-            {   int ret = slice_from_s(z, 4, s_46); /* <-, line 186 */
+            {   int ret = slice_from_s(z, 4, s_36); /* <-, line 186 */
                 if (ret < 0) return ret;
             }
             break;
         case 11:
-            {   int ret = slice_from_s(z, 5, s_47); /* <-, line 187 */
+            {   int ret = slice_from_s(z, 5, s_37); /* <-, line 187 */
                 if (ret < 0) return ret;
             }
             break;
@@ -965,14 +938,15 @@ static int r_exception1(struct SN_env * z) {
     return 1;
 }
 
-static int r_postlude(struct SN_env * z) {
+static int r_postlude(struct SN_env * z) { /* forwardmode */
     if (!(z->B[0])) return 0; /* Boolean test Y_found, line 203 */
     while(1) { /* repeat, line 203 */
         int c1 = z->c;
         while(1) { /* goto, line 203 */
             int c2 = z->c;
             z->bra = z->c; /* [, line 203 */
-            if (!(eq_s(z, 1, s_48))) goto lab1;
+            if (z->c == z->l || z->p[z->c] != 'Y') goto lab1; /* literal, line 203 */
+            z->c++;
             z->ket = z->c; /* ], line 203 */
             z->c = c2;
             break;
@@ -981,7 +955,7 @@ static int r_postlude(struct SN_env * z) {
             if (z->c >= z->l) goto lab0;
             z->c++; /* goto, line 203 */
         }
-        {   int ret = slice_from_s(z, 1, s_49); /* <-, line 203 */
+        {   int ret = slice_from_s(z, 1, s_38); /* <-, line 203 */
             if (ret < 0) return ret;
         }
         continue;
@@ -992,19 +966,19 @@ static int r_postlude(struct SN_env * z) {
     return 1;
 }
 
-extern int english_ISO_8859_1_stem(struct SN_env * z) {
+extern int english_ISO_8859_1_stem(struct SN_env * z) { /* forwardmode */
     {   int c1 = z->c; /* or, line 207 */
-        {   int ret = r_exception1(z);
-            if (ret == 0) goto lab1; /* call exception1, line 207 */
+        {   int ret = r_exception1(z); /* call exception1, line 207 */
+            if (ret == 0) goto lab1;
             if (ret < 0) return ret;
         }
         goto lab0;
     lab1:
         z->c = c1;
         {   int c2 = z->c; /* not, line 208 */
-            {   int ret = z->c + 3;
+            {   int ret = z->c + 3; /* hop, line 208 */
                 if (0 > ret || ret > z->l) goto lab3;
-                z->c = ret; /* hop, line 208 */
+                z->c = ret;
             }
             goto lab2;
         lab3:
@@ -1013,98 +987,94 @@ extern int english_ISO_8859_1_stem(struct SN_env * z) {
         goto lab0;
     lab2:
         z->c = c1;
-        {   int c3 = z->c; /* do, line 209 */
-            {   int ret = r_prelude(z);
-                if (ret == 0) goto lab4; /* call prelude, line 209 */
-                if (ret < 0) return ret;
-            }
-        lab4:
-            z->c = c3;
+        /* do, line 209 */
+        {   int ret = r_prelude(z); /* call prelude, line 209 */
+            if (ret == 0) goto lab4;
+            if (ret < 0) return ret;
         }
-        {   int c4 = z->c; /* do, line 210 */
-            {   int ret = r_mark_regions(z);
-                if (ret == 0) goto lab5; /* call mark_regions, line 210 */
-                if (ret < 0) return ret;
-            }
-        lab5:
-            z->c = c4;
+    lab4:
+        /* do, line 210 */
+        {   int ret = r_mark_regions(z); /* call mark_regions, line 210 */
+            if (ret == 0) goto lab5;
+            if (ret < 0) return ret;
         }
+    lab5:
         z->lb = z->c; z->c = z->l; /* backwards, line 211 */
 
-        {   int m5 = z->l - z->c; (void)m5; /* do, line 213 */
-            {   int ret = r_Step_1a(z);
-                if (ret == 0) goto lab6; /* call Step_1a, line 213 */
+        {   int m3 = z->l - z->c; (void)m3; /* do, line 213 */
+            {   int ret = r_Step_1a(z); /* call Step_1a, line 213 */
+                if (ret == 0) goto lab6;
                 if (ret < 0) return ret;
             }
         lab6:
-            z->c = z->l - m5;
+            z->c = z->l - m3;
         }
-        {   int m6 = z->l - z->c; (void)m6; /* or, line 215 */
-            {   int ret = r_exception2(z);
-                if (ret == 0) goto lab8; /* call exception2, line 215 */
+        {   int m4 = z->l - z->c; (void)m4; /* or, line 215 */
+            {   int ret = r_exception2(z); /* call exception2, line 215 */
+                if (ret == 0) goto lab8;
                 if (ret < 0) return ret;
             }
             goto lab7;
         lab8:
-            z->c = z->l - m6;
-            {   int m7 = z->l - z->c; (void)m7; /* do, line 217 */
-                {   int ret = r_Step_1b(z);
-                    if (ret == 0) goto lab9; /* call Step_1b, line 217 */
+            z->c = z->l - m4;
+            {   int m5 = z->l - z->c; (void)m5; /* do, line 217 */
+                {   int ret = r_Step_1b(z); /* call Step_1b, line 217 */
+                    if (ret == 0) goto lab9;
                     if (ret < 0) return ret;
                 }
             lab9:
-                z->c = z->l - m7;
+                z->c = z->l - m5;
             }
-            {   int m8 = z->l - z->c; (void)m8; /* do, line 218 */
-                {   int ret = r_Step_1c(z);
-                    if (ret == 0) goto lab10; /* call Step_1c, line 218 */
+            {   int m6 = z->l - z->c; (void)m6; /* do, line 218 */
+                {   int ret = r_Step_1c(z); /* call Step_1c, line 218 */
+                    if (ret == 0) goto lab10;
                     if (ret < 0) return ret;
                 }
             lab10:
-                z->c = z->l - m8;
+                z->c = z->l - m6;
             }
-            {   int m9 = z->l - z->c; (void)m9; /* do, line 220 */
-                {   int ret = r_Step_2(z);
-                    if (ret == 0) goto lab11; /* call Step_2, line 220 */
+            {   int m7 = z->l - z->c; (void)m7; /* do, line 220 */
+                {   int ret = r_Step_2(z); /* call Step_2, line 220 */
+                    if (ret == 0) goto lab11;
                     if (ret < 0) return ret;
                 }
             lab11:
-                z->c = z->l - m9;
+                z->c = z->l - m7;
             }
-            {   int m10 = z->l - z->c; (void)m10; /* do, line 221 */
-                {   int ret = r_Step_3(z);
-                    if (ret == 0) goto lab12; /* call Step_3, line 221 */
+            {   int m8 = z->l - z->c; (void)m8; /* do, line 221 */
+                {   int ret = r_Step_3(z); /* call Step_3, line 221 */
+                    if (ret == 0) goto lab12;
                     if (ret < 0) return ret;
                 }
             lab12:
-                z->c = z->l - m10;
+                z->c = z->l - m8;
             }
-            {   int m11 = z->l - z->c; (void)m11; /* do, line 222 */
-                {   int ret = r_Step_4(z);
-                    if (ret == 0) goto lab13; /* call Step_4, line 222 */
+            {   int m9 = z->l - z->c; (void)m9; /* do, line 222 */
+                {   int ret = r_Step_4(z); /* call Step_4, line 222 */
+                    if (ret == 0) goto lab13;
                     if (ret < 0) return ret;
                 }
             lab13:
-                z->c = z->l - m11;
+                z->c = z->l - m9;
             }
-            {   int m12 = z->l - z->c; (void)m12; /* do, line 224 */
-                {   int ret = r_Step_5(z);
-                    if (ret == 0) goto lab14; /* call Step_5, line 224 */
+            {   int m10 = z->l - z->c; (void)m10; /* do, line 224 */
+                {   int ret = r_Step_5(z); /* call Step_5, line 224 */
+                    if (ret == 0) goto lab14;
                     if (ret < 0) return ret;
                 }
             lab14:
-                z->c = z->l - m12;
+                z->c = z->l - m10;
             }
         }
     lab7:
         z->c = z->lb;
-        {   int c13 = z->c; /* do, line 227 */
-            {   int ret = r_postlude(z);
-                if (ret == 0) goto lab15; /* call postlude, line 227 */
+        {   int c11 = z->c; /* do, line 227 */
+            {   int ret = r_postlude(z); /* call postlude, line 227 */
+                if (ret == 0) goto lab15;
                 if (ret < 0) return ret;
             }
         lab15:
-            z->c = c13;
+            z->c = c11;
         }
     }
 lab0:
